Attribute VB_Name = "ModCommon"
Public pubMaintenance As Boolean

Sub AppCal(Modus As Boolean, Optional CalcMode As Long)
 
    If pubMaintenance = True Then Exit Sub
 
    If Modus = False Then
        Application.Calculation = xlCalculationManual
   
    Else
   
        If CalcMode = 0 Then
            Application.Calculation = xlCalculationAutomatic
        Else
            Application.Calculation = CalcMode
        End If
     
    End If
End Sub

Sub AppEv(Modus As Boolean)
    
    If pubMaintenance = True Then Exit Sub
    
    Application.EnableEvents = Modus

End Sub

Sub AppOnOff(Modus)
   
    If pubMaintenance = True Then Exit Sub
   
    With Application
    
        If Modus = False Then
            .Calculation = xlCalculationManual
        Else
            .Calculation = xlCalculationAutomatic
        End If
    
        .EnableEvents = Modus
        .ScreenUpdating = Modus
       
    End With
        
End Sub

Sub AppSc(Modus As Boolean)

 If pubMaintenance = True Then Exit Sub

 Application.ScreenUpdating = Modus
End Sub

Sub ErrMsg(Tekst As String)
 MsgBox (Tekst)
End Sub

'***********************************
'Locks or unlocks sheet sh
'Set Mysecret to a value to
'prevent user from running the sub
'from Immediate window
'***********************************
Sub LockSh(sh As Worksheet, Mysecret As Long, Mode As Boolean)
    
    Dim Secret As Long
    Secret = 432
        
    If Mysecret <> Secret Then
        Exit Sub
    End If
 
    Dim Pwd As String
    Pwd = "k5bs83,8s/a%j"
 
    If Mode = True Then
        
        sh.Protect DrawingObjects:=True, Contents:=True, Scenarios:=True, Password:=Pwd
    
    Else
        
        sh.Unprotect Password:=Pwd
    
    End If


End Sub


'**********************************
'Return first free row in sheet sh
'**********************************
Function ffR(sh As Worksheet) As Long
    ffR = sh.Range("A1").CurrentRegion.Rows.Count + 1
End Function


'*************************************
'Return first free column in sheet sh
'*************************************
Function ffC(sh As Worksheet) As Long
    ffC = sh.Range("A1").CurrentRegion.Columns.Count + 1
End Function


'**************************************
'Return row number from column
'with header Header that equals Content
'***************************************
Function fR(sh As Worksheet, Header As Variant, Content As Variant, Optional GoSilent As Boolean, Optional rowHeader As Long, Optional RowSearchStart As Long) As Long

    Dim TableTop As Long
    If rowHeader = 0 Then
        TableTop = 1
    Else
        TableTop = rowHeader
    End If

    Dim rngColumnHeader As Range
    Dim Col As Long
    
    If Left(Header, 1) <> "#" Then
        Set rngColumnHeader = sh.Range(TableTop & ":" & TableTop).Find(What:=Header, LookIn:=xlValues, Lookat:=xlWhole)
    Else
       Col = Val(Mid(Header, 2))
       Set rngColumnHeader = sh.Range(sh.Cells(TableTop, Col), sh.Cells(TableTop, Col))
    End If

    If Not rngColumnHeader Is Nothing Then

        Dim SearchStart As Long
        If RowSearchStart = 0 Then
            SearchStart = TableTop
        Else
            SearchStart = RowSearchStart
        End If

        With sh
            
            Dim rngEnd As Range
            Set rngEnd = .Range(.Cells(sh.UsedRange.Rows.Count + TableTop, rngColumnHeader.Column), .Cells(sh.UsedRange.Rows.Count + TableTop, rngColumnHeader.Column))
            
            Dim rngSearch As Range
            Set rngSearch = .Range(.Cells(SearchStart, rngColumnHeader.Column), .Cells(sh.UsedRange.Rows.Count + TableTop, rngColumnHeader.Column))
            
        End With

        Dim rngResult As Range
        Set rngResult = rngSearch.Find(What:=Content, LookIn:=xlValues, Lookat:=xlWhole, SearchOrder:=xlByRows, SearchDirection:=xlNext, After:=rngEnd)
        
        If Not rngResult Is Nothing Then
         
            fR = rngResult.Row
        
        End If
       
    Else

        If GoSilent = False Then

            ErrMsg "Cannot find header '" & Header & "' in row " & TableTop & " in sheet " & sh.Name

        End If

    End If

End Function


'******************************************
'Return column number with Header 'Content'
'******************************************
Function fC(sh As Worksheet, Header As Variant, Optional GoSilent As Boolean, Optional rowHeader As Long) As Long

    Dim TableTop As Long
    If rowHeader = 0 Then
        TableTop = 1
    Else
        TableTop = rowHeader
    End If


    Dim rngCol As Range
    Set rngCol = sh.Range(TableTop & ":" & TableTop).Find(What:=Header, LookIn:=xlValues, Lookat:=xlWhole)

    If Not rngCol Is Nothing Then
        
        fC = rngCol.Column
    
    Else
    
        If GoSilent = False Then
       
            ErrMsg "Cannot find header '" & Header & "' in row " & TableTop & " in sheet " & sh.Name
      
        End If
    
    End If

End Function



'**********************************************************
'1) Find ColumnHeader from Header in row 1
'2) Find ColumnReturnHeader from ReturnHeader in row 1
'3) Find row number where Content is found in ColumnHeader
'4) Returns value in ColumnReturnHeader from row in 3)
'5) Error message is supressed if GoSilent is true
'**********************************************************
Function findContent(sh As Worksheet, Header As Variant, Content As Variant, _
ReturnHeader As Variant, Optional GoSilent As Boolean, _
Optional rowHeader As Long) As Variant

    Dim TableTop As Long
    If rowHeader = 0 Then
        TableTop = 1
    Else
        TableTop = rowHeader
    End If

    Dim rngColumnHeader As Range
    Set rngColumnHeader = sh.Range(TableTop & ":" & TableTop). _
    Find(What:=Header, LookIn:=xlValues, Lookat:=xlWhole)
    
    Dim rngColumnReturnHeader As Range
    Set rngColumnReturnHeader = sh.Range(TableTop & ":" & TableTop). _
    Find(What:=ReturnHeader, LookIn:=xlValues, Lookat:=xlWhole)
    
    If Not (rngColumnHeader Is Nothing Or rngColumnReturnHeader Is Nothing) Then

        
        With sh
                        
            Dim rngEnd As Range
            Set rngEnd = .Range(.Cells(sh.UsedRange.Rows.Count + TableTop, _
            rngColumnHeader.Column), .Cells(sh.UsedRange.Rows.Count + TableTop, _
            rngColumnHeader.Column))
            
            
            Dim rngSearch As Range
            Set rngSearch = .Range(.Cells(1, rngColumnHeader.Column), _
            .Cells(sh.UsedRange.Rows.Count + TableTop, rngColumnHeader.Column))
        
        End With

        Dim rngResult As Range
        Set rngResult = rngSearch.Find(What:=Content, LookIn:=xlValues, _
        Lookat:=xlWhole, SearchOrder:=xlByRows, SearchDirection:=xlNext, After:=rngEnd)
        
        If Not rngResult Is Nothing Then
            
            findContent = sh.Cells(rngResult.Row, rngColumnReturnHeader.Column)
        
        End If

    Else
    
        If GoSilent = False Then
    
            Dim msg As String
    
            If rngColumnHeader Is Nothing Then
                msg = "Could not find Header '" & Header _
                & "' in row " & TableTop & " in sheet " & sh.Name
            End If
    
            If rngColumnReturnHeader Is Nothing Then
                msg = msg & Chr(10) & "Could not find ReturnHeader '" & ReturnHeader _
                & "' in row " & TableTop & " in sheet " & sh.Name
            End If
        
            If msg <> "" Then
                ErrMsg msg
            End If
    
        End If

    End If

End Function
